unit AppGlobals;

interface

uses
  StdCtrls;


const
  APP_BETA_BUILD = -1;

  STD_BUFFER_SIZE = 1024*1024*1;  // 1 MB

procedure PopulateRemovableDrives(cbDrive: TComboBox);

implementation


uses
{$WARNINGS OFF}  // Useless warning about platform - don't care about it
  FileCtrl,
{$WARNINGS ON}
  Windows,
  SDUGeneral;

procedure PopulateRemovableDrives(cbDrive: TComboBox);
var
  DriveType: TDriveType;
  drive: char;
  item: string;
  volTitle: string;
  partSize: LARGE_INTEGER;
  strSize: string;
begin
  cbDrive.Items.Clear();

  // Skip "A" and "B"; typically floppy drives
  // Note: *Uppercase* letters
  for drive:='C' to 'Z' do
    begin
    DriveType := TDriveType(GetDriveType(PChar(drive + ':\')));

    if (
        (DriveType = dtFloppy) or
        (DriveType = dtUnknown)
       ) then
      begin
      item := drive+':';

      volTitle := SDUVolumeID(drive);
      partSize := SDUGetPartitionSize(drive);
      if (partSize.QuadPart >= 0) then
        begin
        strSize := SDUFormatUnits(
                                  partSize.quadpart,
                                  ['bytes', 'KB', 'MB', 'GB', 'TB'],
                                  1024,
                                  0
                                 );
        item := item + ' ['+strSize+']';
        end;

      if (volTitle <> '') then
        begin
        item := item+' '+volTitle;
        end;

      cbDrive.Items.Add(item);
      end;

    end;

end;


END.

