unit frame_Location;

interface

uses
{$WARNINGS OFF}  // Useless warning about platform - don't care about it
  FileCtrl,
{$WARNINGS ON}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Tfme_Location = class(TFrame)
    rbDrive: TRadioButton;
    dcbDrive: TDriveComboBox;
    rbDevice: TRadioButton;
    edDevice: TEdit;
    rbFile: TRadioButton;
    edFilename: TEdit;
    pbBrowse: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure rbLocationTypeClick(Sender: TObject);
    procedure pbBrowseClick(Sender: TObject);
  private
    FSaveLocation: boolean;
  public
    function  GetLocation(): string;
    procedure EnableDisableControls();
  published
    property SaveLocation: boolean read FSaveLocation write FSaveLocation;
  end;

implementation

{$R *.dfm}

uses
  SDUGeneral;

function Tfme_Location.GetLocation(): string;
var
  retVal: string;
begin
  retVal:= '';

  if (rbDrive.checked) then
    begin
    retVal := '\\.\'+dcbDrive.Drive+':';
    end
  else if (rbDevice.checked) then
    begin
    retVal := edDevice.Text;
    end
  else if (rbFile.checked) then
    begin
    retVal := edFilename.Text;
    end;

  Result := retVal;
end;

procedure Tfme_Location.pbBrowseClick(Sender: TObject);
begin
  if SaveLocation then
    begin
    SDUOpenSaveDialogSetup(SaveDialog1, edFilename.text);

    if SaveDialog1.Execute then
      begin
      edFilename.text := SaveDialog1.Filename;
      end;
    end
  else
    begin
    SDUOpenSaveDialogSetup(OpenDialog1, edFilename.text);

    if OpenDialog1.Execute then
      begin
      edFilename.text := OpenDialog1.Filename;
      end;

    end;

end;

procedure Tfme_Location.rbLocationTypeClick(Sender: TObject);
begin
  EnableDisableControls();

end;

procedure Tfme_Location.EnableDisableControls();
begin
    SDUEnableControl(dcbDrive, rbDrive.checked);
    SDUEnableControl(edDevice, rbDevice.checked);
    SDUEnableControl(edFilename, rbFile.checked);
    SDUEnableControl(pbBrowse, rbFile.checked);

end;

END.

